    include \masm32\include\masm32rt.inc
    .686
    .mmx
    include \masm32\macros\timers.asm
;==========================================================================
    .data
        strx db "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxx",0
        stry db "yyyyyyyyyyyyyyyyyyyyyyyyyyyyyy",0
    .code
;==========================================================================
; SWAP$(String1:STRING,String2:STRING)
;==========================================================================
align 16

codesize MACRO arg
  tmp$ CATSTR <mov eax, >, <arg>, <_endp>
  tmp$
  sub eax, arg
  tmp$ CATSTR <print str$(eax), 9, "bytes for >, <arg>, <", 13, 10>
  tmp$
ENDM

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

SWAP$ proc psz1:DWORD, psz2:DWORD

      push ebx
      push edi
      push esi
      mov   esi, [esp+20]     ;ESI = Source
      mov   edi, [esp+16]   ;EDI = Destination
      pxor   mm0, mm0    ;zero for comparison mm0
      pxor  mm1, mm1    ;zero for comparison mm1
C5:   movq   mm2, [esi]    ;move 8 bytes into mm2
      movq  mm3, [edi]    ;move 8 bytes into mm3
      pcmpeqb  mm0, mm2    ;set bytes in xmm0 to FF if nullbytes found in xmm2
      pcmpeqb  mm1, mm3    ;set bytes in xmm1 to FF if nullbytes found in xmm3
      xor   ebx, ebx
      movd  ecx, mm0
      test  ecx, ecx
      jnz   @F
      psrlq  mm0, 32
      movd  ecx, mm0
      mov   bl, 4
@@:   movd  edx, mm1
      test  edx, edx
      jnz   @F
      psrlq  mm1, 32
      movd  edx, mm1
      mov   bh, 4
@@:   bsf   ecx, ecx
      setz  al
      shr   ecx, 3
      add   cl, bl
      bsf   edx, edx
      setz  ah
      shr   edx, 3
      add   dl, bh
      test  al, ah
      jz   @F
      movq  [edi], mm2
      movq  [esi], mm3
      lea   esi, [esi+8]
      lea   edi, [edi+8]
      jmp   C5
@@:   cmp   al, ah
      jb   SourceShort
      ja   DestShort
C0:   movd  eax, mm2
      mov   cl, 4
@@:   test  al, al
      stosb
      jz   L0
      shr   eax, 8
      loop  @B
      psrlq  mm2, 32
      jmp   C0
L0:   xchg  edi, esi
C1:   movd  eax, mm3
      mov   cl, 4
@@:   test  al, al
      stosb
      jz   L1
      shr   eax, 8
      loop  @B
      psrlq  mm3, 32
      jmp   C1
L1:   pop esi
      pop edi
      pop ebx
      emms
      ret   8
DestShort: sub   edx, 8
      xchg  edi, esi
      not   edx
C3:   movd  eax, mm3
      mov   cl, 4
@@:   test  al, al
      stosb
      jz   L3
      shr   eax, 8
      loop  @B
      psrlq  mm3, 32
      jmp   C3
L3:   movq  [esi], mm2
      jmp   L4
SourceShort:mov   edx, ecx
      sub   edx, 8
      not   edx
C2:   movd  eax, mm2
      mov   cl, 4
@@:   test  al, al
      stosb
      jz   L2
      shr   eax, 8
      loop  @B
      psrlq  mm2, 32
      jmp   C2
L2:   movq  [esi], mm3
L4:   lea   esi, [esi+8]
      add   edi, edx
      xchg  edi, esi
      mov   ebx, edi
      mov   dl, 3
@@:   test   esi, edx
      jz    L5
      lodsb
      stosb
      test   al, al
      jnz   @B
      jmp   L1
L5:   inc   edx
C4:   mov   ecx, edx
      mov   eax, [esi]
@@:   stosb
      test   al, al
      jz    L1
      shr   eax, 8
      dec   ecx
      jnz   @B
      add   esi, edx
      jmp   C4
SWAP$ endp
SWAP$_endp:

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

;==========================================================================

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

SwapBS proc psz1:DWORD, psz2:DWORD

    push esi
    push edi
    mov esi, [esp+12]
    mov edi, [esp+16]
    xor ecx, ecx
  @@:
    movzx eax, BYTE PTR [esi+ecx]
    movzx edx, BYTE PTR [edi+ecx]
    mov [edi+ecx], al
    mov [esi+ecx], dl
    inc ecx
    test eax, eax
    jnz  @B
    pop edi
    pop esi
    ret 8

SwapBS endp
SwapBS_endp:

SwapJ2$ proc psz1:DWORD, psz2:DWORD
  pop ecx
  xchg esi, [esp]
  xchg edi, [esp+4]
  @@:
    movzx eax, BYTE PTR [esi]
    movzx edx, BYTE PTR [edi]
    mov [edi], al
    inc edi
    mov [esi], dl
    inc esi
    test eax, eax
    jnz  @B
    pop esi
    pop edi
    jmp ecx
SwapJ2$ endp
SwapJ2$_endp:

SwapJ3$ proc psz1:DWORD, psz2:DWORD
  pop ecx
  xchg esi, [esp]
  xchg edi, [esp+4]
  @@:
    lodsb
    movzx edx, BYTE PTR [edi]
    stosb
    mov [esi-1], dl
    test eax, eax
    jnz  @B
    pop esi
    pop edi
    jmp ecx
SwapJ3$ endp
SwapJ3$_endp:

SwapJ1$ proc psz1:DWORD, psz2:DWORD

    push esi
    push edi
    mov esi, [esp+12]
    mov edi, [esp+16]
  @@:
    movzx eax, BYTE PTR [esi]
    movzx edx, BYTE PTR [edi]
    mov [edi], al
    inc edi
    mov [esi], dl
    inc esi
    test eax, eax
    jnz  @B
    pop edi
    pop esi

    ret 8
SwapJ1$ endp
SwapJ1$_endp:

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

;==========================================================================
start:
;==========================================================================
    print ADDR strx,13,10
    print ADDR stry,13,10, 10

    invoke SWAP$, ADDR strx, ADDR stry
    print ADDR strx,13,10
    print ADDR stry,13,10, 10

    invoke SwapBS, ADDR strx, ADDR stry
    print ADDR strx,13,10
    print ADDR stry,13,10,10

    invoke SwapJ1$, ADDR strx, ADDR stry
    print ADDR strx,13,10
    print ADDR stry,13,10,10

    invoke SwapJ2$, ADDR strx, ADDR stry
    print ADDR strx,13,10
    print ADDR stry,13,10,10

    invoke SwapJ3$, ADDR strx, ADDR stry
    print ADDR strx,13,10
    print ADDR stry,13,10,10

    codesize SWAP$
    codesize SwapBS
    codesize SwapJ1$
    codesize SwapJ2$
    codesize SwapJ3$

    print chr$(13, 10)

    invoke Sleep, 1000

    counter_begin 1000, HIGH_PRIORITY_CLASS
        invoke SWAP$, ADDR strx, ADDR stry
    counter_end
    print str$(eax)," cycles, SWAP$",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
        invoke SwapBS, ADDR strx, ADDR stry
    counter_end
    print str$(eax)," cycles, SwapBS",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
        invoke SwapJ1$, ADDR strx, ADDR stry
    counter_end
    print str$(eax)," cycles, SwapJ1$",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
        invoke SwapJ2$, ADDR strx, ADDR stry
    counter_end
    print str$(eax)," cycles, SwapJ2$",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
        invoke SwapJ3$, ADDR strx, ADDR stry
    counter_end
    print str$(eax)," cycles, SwapJ3$",13,10, 10

    inkey "Press any key to exit..."
    exit
;==========================================================================
end start

OPT_WAIT	0
OPT_Tmp2Asm	1
